#!/usr/bin/mumps
#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#+   
#+     Mumps ISR Software Library
#+     Copyright (C) 2007, 2008 by Kevin C. O'Kane  
#+
#+     Kevin C. O'Kane
#+     anamfianna@earthlink.net
#+     okane@cs.uni.edu
#+
#+
#+ This program is free software; you can redistribute it and/or modify
#+ it under the terms of the GNU General Public License as published by
#+ the Free Software Foundation; either version 2 of the License, or
#+ (at your option) any later version.
#+ 
#+ This program is distributed in the hope that it will be useful,
#+ but WITHOUT ANY WARRANTY; without even the implied warranty of
#+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#+ GNU General Public License for more details.
#+ 
#+ You should have received a copy of the GNU General Public License
#+ along with this program; if not, write to the Free Software
#+ Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#+
#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

# docdoc5.mps March 21, 2008

      write !!,"Document-document matrix ",$zd,!

      kill ^dd

      for w=$order(^idf(w)) do
      . for d1=$order(^index(w,d1)) do
      .. for d2=d1:$order(^index(w,d2)):"" do
      ... if $data(^dd(d1,d2)) quit
      ... set ^dd(d1,d2)=$zzCosine(^doc(d1),^doc(d2))

      for d1="":$order(^dd(d1)):"" do
      . for d2="":$order(^dd(d1,d2)):"" do
      .. if ^dd(d1,d2)<wgt kill ^dd(d1,d2)
      .. else  set ^dd(d2,d1)=^dd(d1,d2)

      for d1="":$order(^dd(d1)):"" do
      . write !,d1,": ",?10
      . set k=0
      . for d2="":$order(^dd(d1,d2)):"" do
      .. write d2,"(",$justify(^dd(d1,d2),1,2),") "
      .. set k=k+1
      .. if k#7=0 write !,?10
