#!/usr/bin/mumps
#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#+
#+     Mumps ISR Software Library
#+     Copyright (C) 2006, 2007, 2008 by Kevin C. O'Kane
#+
#+     Kevin C. O'Kane
#+     okane@cs.uni.edu
#+
#+
#+ This program is free software; you can redistribute it and/or modify
#+ it under the terms of the GNU General Public License as published by
#+ the Free Software Foundation; either version 2 of the License, or
#+ (at your option) any later version.
#+
#+ This program is distributed in the hope that it will be useful,
#+ but WITHOUT ANY WARRANTY; without even the implied warranty of
#+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#+ GNU General Public License for more details.
#+
#+ You should have received a copy of the GNU General Public License
#+ along with this program; if not, write to the Free Software
#+ Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#+
#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

# reformatX.mps March 21, 2008

      open 1:"osu.medline,old"
      if '$test write "osu.medline file not found",! halt

      if '$data(MAX) set MAX=1000

      set D=0

      for  do  if D>MAX quit
      . use 1 set o=$ztell read line
      . if '$test break // no more input
      . if $extract(line,1,2)="TI" do  quit
      .. set D=D+1,^doc(D)=off,^title(D)=$extract(line,7,256)
      .. use 5
      .. write off," ",D," ",$extract(line,7,1023),!
      .. quit
      . if $extract(line,1,2)="MH" quit
      . if $extract(line,1,13)="STAT- MEDLINE" set off=o use 5 write "xxxxx115xxxxx " quit
      . if $extract(line,1,2)'="AB" quit
      . use 5 write $extract(line,7,1023)," "
      . for  do  // for each line of the abstract
      .. use 1 read line
      .. if '$test break // no more input
      .. if line="" break
      .. set line=$extract(line,7,255)
      .. use 5 write line," "
      . use 5 write ! // line after abstract

      close 1
      open 1:"titles,new"
      use 1
      for i=$order(^title(i)) write i," ",^title(i),!
      use 5
      close 1
