#!/usr/bin/mumps
#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#+   
#+     Mumps ISR Software Library
#+     Copyright (C) 2005, 2006, 2008 by Kevin C. O'Kane  
#+
#+     Kevin C. O'Kane
#+     okane@cs.uni.edu
#+
#+
#+ This program is free software; you can redistribute it and/or modify
#+ it under the terms of the GNU General Public License as published by
#+ the Free Software Foundation; either version 2 of the License, or
#+ (at your option) any later version.
#+ 
#+ This program is distributed in the hope that it will be useful,
#+ but WITHOUT ANY WARRANTY; without even the implied warranty of
#+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#+ GNU General Public License for more details.
#+ 
#+ You should have received a copy of the GNU General Public License
#+ along with this program; if not, write to the Free Software
#+ Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#+
#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
# display.mps March 25, 2008

      html Content-type: text/html &!&!
      html <html><body bgcolor=silver>

      if '$data(ref) write "Missing reference number </body></html>" halt

      open 1:"osu.medline,old"
      if '$test write "osu.medline not found",! halt

      use 1 set %=$zseek(^doc(ref))

      html <table bgcolor=lightsteelblue align=center width=60% border><tr><td><i>Mesh Headings:</i><br>
      set flg=0
      for  do
      . use 1
      . read a                  // find the title
      . if a="" do
      .. html No abstract available
      .. html </table></body></html>
      .. halt
      . if $extract(a,1,3)="MH " do
      .. use 5
      .. set i=$find(a,"/")
      .. if i=0 set i=255
      .. else  set i=i-2
      .. set a=$extract(a,7,i)
      .. do $zwi(a)
      .. for ww=$zwp do
      ... if ww?.p continue
      ... set wx=ww
      ... if $data(^lib($e(wx,1,1),wx)) do
      .... html <a href=index.cgi?
      .... html array=lib&ml=3&a1=&~$e(wx,1,1)~&a2=&~wx~#node2>
      .... write ww,"</a> "
      ... else  write ww," "

      . if $extract(a,1,3)="TI " do
      .. use 5
      .. do $zwi($extract(a,7,255))
      .. html <tr><td><i>Title:&nbsp;</i>
      .. for ww=$zwp do
      ... set wx=ww
      ... if $data(^lib($e(wx,1,1),wx)) do
      .... html <a href=index.cgi?
      .... html array=lib&ml=3&a1=&~$e(wx,1,1)~&a2=&~wx~#node2>
      .... write ww,"</a> "
      ... else  write ww," "
      .. html </td><tr><td><i>Abstract:</i>&nbsp;
      . if $extract(a,1,3)="AB " for  do
      .. use 5
      .. do $zwi($extract(a,7,255))
      .. for ww=$zwp do
      ... set wx=ww
      ... if $data(^lib($e(wx,1,1),wx)) do
      .... html <a href=index.cgi?
      .... html array=lib&ml=3&a1=&~$e(wx,1,1)~&a2=&~wx~#node2>
      .... write ww,"</a> "
      ... else  write ww," "
      .. use 1 read a
      .. if a=""!($extract(a,1,3)'="   ") set flg=1 break
      . if flg break

      use 5
      html <tr><td><i>Related Documents</i>:
      set d=""
      for  do
      . set d=$order(^dd(ref,d))
      . if d="" break
      . use 1 set %=$zseek(^doc(d))
      . for  do
      .. use 1
      .. read a                  // find the title
      .. if a="" do
      ... html </table></body></html>
      ... halt
      .. if $extract(a,1,3)="TI " do
      ... use 5
      ... html <br><a href=display.cgi?ref=
      ... write d,">",d,"</a> "
      ... do $zwi($extract(a,7,255))
      ... for ww=$zwp do
      .... set wx=ww
      .... if $data(^lib($e(wx,1,1),wx)) do
      ..... html <a href=index.cgi?
      ..... html array=lib&ml=3&a1=&~$e(wx,1,1)~&a2=&~wx~#node2>
      ..... write ww,"</a> "
      .... else  write ww," "
      html </table></body></html>

