#!/usr/bin/mumps
#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#+
#+     Mumps ISR Software Library
#+     Copyright (C) 2006, 2008 by Kevin C. O'Kane
#+
#+     Kevin C. O'Kane
#+     okane@cs.uni.edu
#+
#+
#+ This program is free software; you can redistribute it and/or modify
#+ it under the terms of the GNU General Public License as published by
#+ the Free Software Foundation; either version 2 of the License, or
#+ (at your option) any later version.
#+
#+ This program is distributed in the hope that it will be useful,
#+ but WITHOUT ANY WARRANTY; without even the implied warranty of
#+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#+ GNU General Public License for more details.
#+
#+ You should have received a copy of the GNU General Public License
#+ along with this program; if not, write to the Free Software
#+ Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#+
#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

# idf-cutoff.mps March 21, 2008


      if '$data(min) set min=5

      for  do
      . read a
      . if '$test break
      . set wgt=$p(a," ",1)
      . if wgt<min quit
      . set w=$p(a," ",2)
      . if $len(w)<4 quit
      . if w?.E1N.E quit //no embedded numbers
      . set ^idf(w)=wgt
      . write a,!

      open 1:"translated.txt,old"
      if '$test write "translated not found",! halt
      use 1

      for  do
      . use 1
      . set word=$zzScan
      . if '$test break
      . if word="xxxxx115xxxxx" set off=$zzScan,doc=$zzScan,^doc(doc)=off quit
      . if '$data(^idf(word)) quit 
      . if $data(^doc(doc,word)) set ^doc(doc,word)=^doc(doc,word)+1
      . else  set ^doc(doc,word)=1
      . if $data(^dict(word)) set ^dict(word)=^dict(word)+1
      . else  set ^dict(word)=1

      use 5
      close 1
      set ^DocCount(1)=doc

      open 1:"titles,old"
      use 1
      for  do
      . read a
      . if '$test break
      . set i=$p(a," ",1)
      . set ^title(i)=a
      use 5

      halt

