#!/usr/bin/mumps
#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#+   
#+     Mumps ISR Software Library
#+     Copyright (C) 2000, 2005, 2006, 2008 by Kevin C. O'Kane  
#+
#+     Kevin C. O'Kane
#+     anamfianna@earthlink.net
#+     okane@cs.uni.edu
#+
#+
#+ This program is free software; you can redistribute it and/or modify
#+ it under the terms of the GNU General Public License as published by
#+ the Free Software Foundation; either version 2 of the License, or
#+ (at your option) any later version.
#+ 
#+ This program is distributed in the hope that it will be useful,
#+ but WITHOUT ANY WARRANTY; without even the implied warranty of
#+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#+ GNU General Public License for more details.
#+ 
#+ You should have received a copy of the GNU General Public License
#+ along with this program; if not, write to the Free Software
#+ Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#+
#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

# webFinder.mps March 25, 2008

#$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
#
# Note: this program must be compiled due to some features
#       presently only available in the compiler.
#
#$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

      html Content-type: text/html &!&!
      set t=$zd1

      html <html><body bgcolor=silver>

      if '$data(query) set query=""
      html <center><img src=http://sidhe.cs.uni.edu/moogle.gif border=0><br>
      html <form name="f1" method="get" action="webFinder.cgi">
      html <input type="text" name="query" size=50 maxlength=128 value="&~query~">
      html &nbsp <input type="submit" value="Search">
      html </form>
      html <form name="f1" method="get" action="webFinder.cgi">
      html <input type="hidden" name="query" value="###">
      html &nbsp <input type="submit" value="I'm Feeling Sick">
      html </form></center>
      write !

      if query="" write "</body></html>",! halt

      if query="###" do
      . set w=""
      . for i=1:1 do
      .. set w=$order(^dict(w))
      .. if w="" break
      . set j=$r(i-1)
      . set w=""
      . for i=1:1:j do
      .. set w=$order(^dict(w))
      . set query=w

      kill ^d
      kill ^query

      do $zwi(query)
      set wx=0
      for w=$zwp do
      . if w?.P continue
      . set ^query(w)=1
      . for d="":$order(^index(w,d)):"" set ^d(d)=""

      Set i=$zwi(query)
      set exp=""
      for w=$zwp do
      . if w="" break
      . if $find("&()",w) set exp=exp_w continue
      . if w="|" set exp=exp_"!" continue
      . if w="~" set exp=exp_"'" continue
      . set exp=exp_"$d(^doc(d,"""_w_"""))"

      write "<br>",exp,"<br>",!

      kill ^dx
      set max=0
      set count=0
      for d="":$order(^d(d)):"" do
      . try NoMessages set %=@exp
      . catch InterpreterException write "Query parse error.</body></html>",! halt
      . if %>0 do
      .. set C=$zzCosine(^query,^doc(d))
      .. set ^dx(C,d)=""
      .. set count=count+1

      write count," pages found - top 10 shown<hr><tt><pre>",!
      set d=""
      set i=0
      for  do
      . if i>10 break
      . set d=$order(^dx(d),-1)
      . if d="" break
      . for dd="":$order(^dx(d,dd)):"" do
      .. set i=i+1
      .. if i>10 break
      .. write $j(d,6,3)," "
      .. write "<a href=display.cgi?ref=",dd,">"
      .. write $j(dd,6)," ",$extract(^title(dd),1,90),"</a>",!

      write "<pre><p>Time used: ",$zd1-t,"<br>",!
      html </body></html>
      kill ^d
      kill ^dx
      halt
