#!/usr/bin/mumps
#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#+
#+     Mumps ISR Software Library
#+     Copyright (C) 2006, 2008 by Kevin C. O'Kane
#+
#+     Kevin C. O'Kane
#+     okane@cs.uni.edu
#+
#+
#+ This program is free software; you can redistribute it and/or modify
#+ it under the terms of the GNU General Public License as published by
#+ the Free Software Foundation; either version 2 of the License, or
#+ (at your option) any later version.
#+
#+ This program is distributed in the hope that it will be useful,
#+ but WITHOUT ANY WARRANTY; without even the implied warranty of
#+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#+ GNU General Public License for more details.
#+
#+ You should have received a copy of the GNU General Public License
#+ along with this program; if not, write to the Free Software
#+ Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#+
#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

# weight.mps March 21, 2008

      open 1:"osu.medline,old"
      if '$test write "cannot find osu.medline",! halt

      open 2:"weighted-doc-vectors,new"

      for d="":$order(^doc(d)):"" do
      . if $order(^doc(d,""))="" quit
      . use 2 write "doc=",d,?15
      . use 1
      . set %=$zseek(^doc(d))
      . for  do
      .. read t
      .. if $e(t,1,2)'="TI" quit
      .. break
      . use 2 write $e(t,7,256),!,?15
      . for w="":$order(^doc(d,w)):"" do
      .. set x=^idf(w)*^doc(d,w)
      .. set ^doc(d,w)=x
      .. write w,"(",x,") "
      . write !
      close 2
      close 1

      set %=$zzTranspose(^doc,^index)

      open 2:"weighted-term-vectors,new"
      use 2
      for w="":$order(^index(w)):"" do
      . write w,?26
      . for d="":$order(^index(w,d)):"" do
      .. write d,"(",^index(w,d),") "
      . write !
      close 2

      for w="":$order(^idf(w)):"" do
      . if '$data(^index(w)) kill ^idf(w)


